cr .( assembler ) cr 
HEX

VARIABLE h
VARIABLE lasth 0 lasth !                  \ init linkfield address lfa

: namer! ( d -- )
   h @ ram!                             \ store double to code buffer
   1 h +!                             \ bump nameh
   ;

: COMPILE-ONLY 10000 lasth @ ram@ XOR lasth @ ram! ;
: IMMEDIATE    20000 lasth @ ram@ XOR lasth @ ram! ;

VARIABLE hi   VARIABLE hw VARIABLE bi ( for packing)
: org   DUP . CR h ! ;
: allot ( n -- ) h +! ;

OCTAL
: #,   ( d ) h @ ram!  1 h +! ;
: ,w   ( d ) hw @ ram@  OR  hw @ ram! ;
: ,i   ( d ) h @ hw ! 77 AND 10000 * #,  ;
: ,y   ( d ) 17777 AND ,w ;
: ,b   ( c ) 377 AND
	bi @ 0 = IF 1 bi ! h @ hw ! 0 #, 400 * ,w EXIT THEN
	0 bi ! ,w ;
: ,n	( count )
	1 bi ! h @ hw ! 0 #, 400 * ,w ;
: inst  CONSTANT DOES> R> @ ,i ,y ;
: anew  0 bi ! ;

HEX
: (makehead)
   anew
   20 WORD                                \ get name of new definition
   lasth @ namer!                         \ fill link field of last word
   h @ lasth !                        \ save nfa in lasth
   COUNT DUP ,n                                \ store count
   FOR AFT 
      COUNT ,b                              \ fill name field
   THEN NEXT
   DROP anew
   ;

: makehead
   >IN @ >R                               \ save interpreter pointer
   (makehead)
   R> >IN !                               \ restore word pointer
   ;

: $LIT ( -- )
   anew
   22 WORD
   COUNT DUP ,n ( compile count )
   FOR AFT
      COUNT ,b ( compile characters )
   THEN NEXT
   DROP anew ;

cr .( machine code ) cr 

OCTAL

  02 inst and  04 inst ior  06 inst xor  10 inst xct
  12 inst ddx  14 inst dsp  16 inst cal  17 inst jda  20 inst lac
  22 inst lio  24 inst dac  26 inst dap  30 inst dip
  32 inst dio  34 inst dzm               40 inst add   
  42 inst sub  44 inst idx  46 inst isp  50 inst sad
  52 inst sas  54 inst mus  56 inst dis  60 inst jmp
  62 inst jsp  64 inst skp  66 inst sft  70 inst law 71 inst lawn
  72 inst iotr 73 inst iotw 76 inst opr

: () ( n -- n, add indirect bit ) 7777 AND 10000 OR ;

: sza 100 skp ;  : szan 100 () skp ;
: spa 200 skp ;  : span 200 () skp ;
: sma 400 skp ;  : sman 400 () skp ;
: szo 1000 skp ;  : szon 1000 () skp ;
: spi 2000 skp ;  : spin 2000 () skp ;

: rar 11000 sft ;
: ral 01000 sft ;
: sar 15000 sft ;
: sal 05000 sft ;
: rir 12000 sft ;
: ril 02000 sft ;
: sir 16000 sft ;
: sil 06000 sft ;
: rcr 13000 sft ;
: rcl 03000 sft ;
: scr 17000 sft ;
: scl 07000 sft ;

: cli 04000 opr ;
: lat 02000 opr ;
: cma 01000 opr ;
: hlt 00400 opr ;
: cla 00200 opr ;
: nop 00000 opr ;

: ':   h @ .head CONSTANT  DOES> R> @ jmp ;
: CODE  makehead ': ;            \ for eforth kernel words
: code  makehead ': ;            \ for eforth kernel words
: label h @ CONSTANT ;


HEX 




















